package com.mycompany.reporteexcel;

import java.awt.Color;
import java.awt.event.KeyEvent;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.file.Paths;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.text.AbstractDocument;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.DocumentFilter;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

public class panel extends javax.swing.JFrame {

    String selectedFolderPath = "";
    ApiData api = new ApiData();
    ExcelService service = new ExcelService();

    private final String[] empresasFranquicia = {
        "---", "MARSHAL", "AVANTE", "ESCOBAR", "JOEL JAICO", "PAVENT SCHOLL",
        "HERSURA", "ROBERT RIVERA", "SACO OLIVEROS  HUAYCAN", "CAJAMARCA",
        "OLIVER SCHOOL", "COLEGIO SACO OLIVEROS PRO S.A.C.", "ASOCIACIÓN WESLEY",
        "GRUPO EDUCA LIMA S.A.C.", "GAMANSA EDUCADORES SRL", "ASOCIACION EDUCATIVA FAROVI"
    };

    private final String[] empresasSede = {
        "---", "SACO OLIVEROS", "APEIRON", "SISTEMA HELICOIDAL", "SOCIEDAD SACO OLIVEROS S.A.C."
    };

    public panel() {
        initComponents();
        setMaxCharacters(txtFecha, 10);
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        btnExportar = new javax.swing.JToggleButton();
        jLabel1 = new javax.swing.JLabel();
        findFolder = new javax.swing.JButton();
        txtRuta = new javax.swing.JLabel();
        mensaje = new javax.swing.JLabel();
        progressBar = new javax.swing.JProgressBar();
        razonSocial = new javax.swing.JComboBox<>();
        jLabel2 = new javax.swing.JLabel();
        periodo = new javax.swing.JComboBox<>();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        empresa = new javax.swing.JComboBox<>();
        jLabel5 = new javax.swing.JLabel();
        txtFecha = new javax.swing.JTextField(10);
        jLabel6 = new javax.swing.JLabel();
        chkDiciembre = new javax.swing.JCheckBox();
        chkMatricula = new javax.swing.JCheckBox();
        chkFebrero = new javax.swing.JCheckBox();
        chkMarzo = new javax.swing.JCheckBox();
        chkAbril = new javax.swing.JCheckBox();
        chkMayo = new javax.swing.JCheckBox();
        chkJunio = new javax.swing.JCheckBox();
        chkJulio = new javax.swing.JCheckBox();
        chkAgosto = new javax.swing.JCheckBox();
        chkSetiembre = new javax.swing.JCheckBox();
        chkOctubre = new javax.swing.JCheckBox();
        chkNoviembre = new javax.swing.JCheckBox();
        chkEnero = new javax.swing.JCheckBox();
        jLabel7 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setResizable(false);

        jPanel1.setBackground(new java.awt.Color(51, 51, 51));
        jPanel1.setForeground(new java.awt.Color(51, 51, 51));
        jPanel1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        btnExportar.setText("EXPORTAR REPORTE");
        btnExportar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnExportarActionPerformed(evt);
            }
        });
        jPanel1.add(btnExportar, new org.netbeans.lib.awtextra.AbsoluteConstraints(370, 60, -1, -1));

        jLabel1.setFont(new java.awt.Font("Noto Sans", 1, 14)); // NOI18N
        jLabel1.setForeground(new java.awt.Color(255, 255, 255));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("RUTA:");
        jPanel1.add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 270, 200, -1));

        findFolder.setText("SELECCIONAR RUTA");
        findFolder.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                findFolderActionPerformed(evt);
            }
        });
        jPanel1.add(findFolder, new org.netbeans.lib.awtextra.AbsoluteConstraints(370, 120, -1, -1));

        txtRuta.setForeground(new java.awt.Color(255, 255, 255));
        jPanel1.add(txtRuta, new org.netbeans.lib.awtextra.AbsoluteConstraints(220, 270, 320, 20));

        mensaje.setForeground(new java.awt.Color(255, 0, 0));
        mensaje.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jPanel1.add(mensaje, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 320, 530, 20));

        progressBar.setBackground(new java.awt.Color(51, 51, 51));
        progressBar.setForeground(new java.awt.Color(102, 102, 102));
        progressBar.setBorder(new javax.swing.border.MatteBorder(null));
        jPanel1.add(progressBar, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 300, 530, 10));

        razonSocial.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "---" }));
        jPanel1.add(razonSocial, new org.netbeans.lib.awtextra.AbsoluteConstraints(190, 60, 150, -1));

        jLabel2.setFont(new java.awt.Font("Noto Sans", 1, 13)); // NOI18N
        jLabel2.setForeground(new java.awt.Color(255, 255, 255));
        jLabel2.setText("FECHA DE CORTE");
        jPanel1.add(jLabel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(190, 100, 150, -1));

        periodo.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "---", "2025", "2024", "2023", "2022", "2021", "2020", "2019", "2018", "2017", "2016", "2015", "2014" }));
        jPanel1.add(periodo, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 120, 150, -1));

        jLabel3.setFont(new java.awt.Font("Noto Sans", 1, 13)); // NOI18N
        jLabel3.setForeground(new java.awt.Color(255, 255, 255));
        jLabel3.setText("PERIODO");
        jPanel1.add(jLabel3, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 100, 150, -1));

        jLabel4.setFont(new java.awt.Font("Noto Sans", 1, 13)); // NOI18N
        jLabel4.setForeground(new java.awt.Color(255, 255, 255));
        jLabel4.setText("TIPO EMPRESA");
        jPanel1.add(jLabel4, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 40, 150, -1));

        empresa.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "---", "FRANQUICIA", "SEDE" }));
        empresa.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                empresaActionPerformed(evt);
            }
        });
        jPanel1.add(empresa, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 60, 150, -1));

        jLabel5.setFont(new java.awt.Font("Noto Sans", 1, 13)); // NOI18N
        jLabel5.setForeground(new java.awt.Color(255, 255, 255));
        jLabel5.setText("RAZÓN SOCIAL");
        jPanel1.add(jLabel5, new org.netbeans.lib.awtextra.AbsoluteConstraints(190, 40, 150, -1));

        txtFecha.setColumns(10);
        txtFecha.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                txtFechaKeyPressed(evt);
            }
        });
        jPanel1.add(txtFecha, new org.netbeans.lib.awtextra.AbsoluteConstraints(190, 120, 150, 30));

        jLabel6.setFont(new java.awt.Font("Noto Sans", 1, 13)); // NOI18N
        jLabel6.setForeground(new java.awt.Color(255, 255, 255));
        jLabel6.setText("CONCEPTO DE PAGO");
        jPanel1.add(jLabel6, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 170, 420, 30));

        chkDiciembre.setForeground(new java.awt.Color(255, 255, 255));
        chkDiciembre.setText("Diciembre");
        chkDiciembre.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkDiciembreActionPerformed(evt);
            }
        });
        jPanel1.add(chkDiciembre, new org.netbeans.lib.awtextra.AbsoluteConstraints(430, 240, -1, -1));

        chkMatricula.setForeground(new java.awt.Color(255, 255, 255));
        chkMatricula.setText("Matricula");
        chkMatricula.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkMatriculaActionPerformed(evt);
            }
        });
        jPanel1.add(chkMatricula, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 200, -1, -1));

        chkFebrero.setForeground(new java.awt.Color(255, 255, 255));
        chkFebrero.setText("Febrero");
        chkFebrero.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkFebreroActionPerformed(evt);
            }
        });
        jPanel1.add(chkFebrero, new org.netbeans.lib.awtextra.AbsoluteConstraints(80, 220, -1, -1));

        chkMarzo.setForeground(new java.awt.Color(255, 255, 255));
        chkMarzo.setText("Marzo");
        chkMarzo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkMarzoActionPerformed(evt);
            }
        });
        jPanel1.add(chkMarzo, new org.netbeans.lib.awtextra.AbsoluteConstraints(160, 220, -1, -1));

        chkAbril.setForeground(new java.awt.Color(255, 255, 255));
        chkAbril.setText("Abril");
        chkAbril.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkAbrilActionPerformed(evt);
            }
        });
        jPanel1.add(chkAbril, new org.netbeans.lib.awtextra.AbsoluteConstraints(250, 220, -1, -1));

        chkMayo.setForeground(new java.awt.Color(255, 255, 255));
        chkMayo.setText("Mayo");
        chkMayo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkMayoActionPerformed(evt);
            }
        });
        jPanel1.add(chkMayo, new org.netbeans.lib.awtextra.AbsoluteConstraints(330, 220, -1, -1));

        chkJunio.setForeground(new java.awt.Color(255, 255, 255));
        chkJunio.setText("Junio");
        chkJunio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkJunioActionPerformed(evt);
            }
        });
        jPanel1.add(chkJunio, new org.netbeans.lib.awtextra.AbsoluteConstraints(430, 220, -1, -1));

        chkJulio.setForeground(new java.awt.Color(255, 255, 255));
        chkJulio.setText("Julio");
        chkJulio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkJulioActionPerformed(evt);
            }
        });
        jPanel1.add(chkJulio, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 240, -1, -1));

        chkAgosto.setForeground(new java.awt.Color(255, 255, 255));
        chkAgosto.setText("Agosto");
        chkAgosto.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkAgostoActionPerformed(evt);
            }
        });
        jPanel1.add(chkAgosto, new org.netbeans.lib.awtextra.AbsoluteConstraints(80, 240, -1, -1));

        chkSetiembre.setForeground(new java.awt.Color(255, 255, 255));
        chkSetiembre.setText("Setiembre");
        chkSetiembre.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkSetiembreActionPerformed(evt);
            }
        });
        jPanel1.add(chkSetiembre, new org.netbeans.lib.awtextra.AbsoluteConstraints(160, 240, -1, -1));

        chkOctubre.setForeground(new java.awt.Color(255, 255, 255));
        chkOctubre.setText("Octubre");
        chkOctubre.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkOctubreActionPerformed(evt);
            }
        });
        jPanel1.add(chkOctubre, new org.netbeans.lib.awtextra.AbsoluteConstraints(250, 240, -1, -1));

        chkNoviembre.setForeground(new java.awt.Color(255, 255, 255));
        chkNoviembre.setText("Noviembre");
        chkNoviembre.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkNoviembreActionPerformed(evt);
            }
        });
        jPanel1.add(chkNoviembre, new org.netbeans.lib.awtextra.AbsoluteConstraints(330, 240, -1, -1));

        chkEnero.setForeground(new java.awt.Color(255, 255, 255));
        chkEnero.setText("Enero");
        chkEnero.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkEneroActionPerformed(evt);
            }
        });
        jPanel1.add(chkEnero, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 220, -1, -1));

        jLabel7.setFont(new java.awt.Font("Noto Sans", 3, 10)); // NOI18N
        jLabel7.setForeground(new java.awt.Color(102, 102, 102));
        jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel7.setText("EJEMPLO: dd/MM/AAAA");
        jPanel1.add(jLabel7, new org.netbeans.lib.awtextra.AbsoluteConstraints(190, 160, 150, -1));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 546, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 362, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void findFolderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_findFolderActionPerformed
        JFileChooser folderChooser = new JFileChooser();
        folderChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY); // Solo permitir carpetas
        folderChooser.setDialogTitle("Seleccionar Carpeta");

        int returnValue = folderChooser.showOpenDialog(this); // Mostrar diálogo

        if (returnValue == JFileChooser.APPROVE_OPTION) {
            File selectedFolder = folderChooser.getSelectedFile();
            selectedFolderPath = selectedFolder.getAbsolutePath(); // Guardar la ruta
            txtRuta.setText(selectedFolderPath);
            System.out.println("Carpeta seleccionada: " + selectedFolderPath);
        } else {
            System.out.println("Selección cancelada");
        }
    }//GEN-LAST:event_findFolderActionPerformed

    private void btnExportarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnExportarActionPerformed

        String empresaValue = empresa.getSelectedItem().toString();

        final int empresaInt;
        switch (empresaValue) {
            case "FRANQUICIA" :
                empresaInt = 2571;break;
            case "SEDE":
                empresaInt = 2572;break;
            default :
                empresaInt = 0;break;
        }

        String razonSocialValue = razonSocial.getSelectedItem().toString();
        final int razonSocialInt;
        switch (razonSocialValue) {
            case "MARSHAL":
                razonSocialInt = 5455;break;
            case "AVANTE":
                razonSocialInt = 5458;break;
            case "ESCOBAR":
                razonSocialInt = 5459;break;
            case "JOEL JAICO":
                razonSocialInt = 5461;break;
            case "PAVENT SCHOLL":
                razonSocialInt = 5463;break;
            case "HERSURA":
                razonSocialInt = 5464;break;
            case "ROBERT RIVERA":
                razonSocialInt = 5466;break;
            case "SACO OLIVEROS  HUAYCAN":
                razonSocialInt = 7034;break;
            case "CAJAMARCA":
                razonSocialInt = 7371;break;
            case "OLIVER SCHOOL":
                razonSocialInt = 7395;break;
            case "COLEGIO SACO OLIVEROS PRO S.A.C.":
                razonSocialInt = 7435;break;
            case "ASOCIACIÓN WESLEY":
                razonSocialInt = 7440;break;
            case "GRUPO EDUCA LIMA S.A.C.":
                razonSocialInt = 7449;break;
            case "GAMANSA EDUCADORES SRL":
                razonSocialInt = 7472;break;
            case "ASOCIACION EDUCATIVA FAROVI":
                razonSocialInt = 8706;break;
            case "SACO OLIVEROS":
                razonSocialInt = 1;break;
            case "APEIRON":
                razonSocialInt = 2;break;
            case "SISTEMA HELICOIDAL":
                razonSocialInt = 3;break;
            case "SOCIEDAD SACO OLIVEROS S.A.C.":
                razonSocialInt = 6796;break;
            default:
                razonSocialInt = 0;break;
        }

        String periodoValue = periodo.getSelectedItem().toString();
        final AtomicInteger periodoInt = new AtomicInteger();

        if (!"---".equals(periodoValue)) {
            periodoInt.set(Integer.parseInt(periodoValue));
        } else {
            periodoInt.set(2012);
        }

        periodoInt.set(periodoInt.get() - 2012);

        String fecha = txtFecha.getText();

        final String conceptoPago = formatConceptoPago(
                chkMatricula, chkEnero, chkFebrero, chkMarzo, chkAbril, chkMayo, chkJunio,
                chkJulio, chkAgosto, chkSetiembre, chkOctubre, chkNoviembre, chkDiciembre
        );

        System.out.println("empresaInt " + empresaInt);
        System.out.println("razonSocialInt " + razonSocialInt);
        System.out.println("periodoInt " + periodoInt);
        System.out.println("fecha " + fecha);
        System.out.println("conceptoPago " + conceptoPago);

        if (periodoInt.get() == 0 || fecha.isEmpty() || "{}".equals(conceptoPago)) {
            JOptionPane.showMessageDialog(null, "Periodo, Fecha de corte y Conceptos de Pagos son requeridos.", "Validación Erronea", JOptionPane.ERROR_MESSAGE);
        } else if (!isValidDate(fecha)) {
            JOptionPane.showMessageDialog(null, "No es una fecha valida", "Validación Erronea", JOptionPane.ERROR_MESSAGE);
        } else {

            btnExportar.setEnabled(false);
            progressBar.setValue(0);
            // Crear un hilo para ejecutar la tarea en segundo plano
            new Thread(new Runnable() {
                @Override
                public void run() {
                    try {

                        // Verificar la ruta
                        if (selectedFolderPath == null || selectedFolderPath.isEmpty()) {
                            selectedFolderPath = Paths.get(System.getProperty("user.home"), "Desktop").toString();
                        }

                        // Actualizar la UI con la ruta seleccionada
                        SwingUtilities.invokeLater(() -> txtRuta.setText(selectedFolderPath));

                        // Actualizar UI antes de iniciar la tarea
                        SwingUtilities.invokeLater(() -> {
                            mensaje.setForeground(Color.WHITE);
                            mensaje.setText("Obteniendo información...");
                        });

                        JSONObject obj = api.conseguirDataReporte(empresaInt, razonSocialInt, periodoInt.get(), fecha, conceptoPago);

                        SwingUtilities.invokeLater(() -> mensaje.setText("Generando Excel..."));

                        JSONArray identifiers = new JSONArray();
                        identifiers.put("sede");
                        identifiers.put("niveles");
                        identifiers.put("estudiante");
                        identifiers.put("documento");
                        identifiers.put("estado");
                        identifiers.put("fecha_matricula");
                        identifiers.put("nivel");
                        identifiers.put("grado");
                        identifiers.put("turno");
                        identifiers.put("concepto_pago_nombre");
                        identifiers.put("plan_total_deuda");
                        identifiers.put("plan_total_pagado");
                        identifiers.put("total_neto");

                        JSONArray data = obj.getJSONArray("data");

                        // Crear el nuevo objeto con los encabezados
                        JSONObject headers = new JSONObject();
                        headers.put("sede", "SEDE:");
                        headers.put("niveles", "NIVELES:");
                        headers.put("estudiante", "ESTUDIANTE:");
                        headers.put("documento", "DOCUMENTO:");
                        headers.put("estado", "ESTADO:");
                        headers.put("fecha_matricula", "FECHA MATRÍCULA:");
                        headers.put("nivel", "NIVEL:");
                        headers.put("grado", "GRADO:");
                        headers.put("turno", "TURNO:");
                        headers.put("concepto_pago_nombre", "CONCEPTO DE PAGO:");
                        headers.put("plan_total_deuda", "TOTAL DEUDA:");
                        headers.put("plan_total_pagado", "TOTAL PAGADO:");
                        headers.put("total_neto", "TOTAL NETO:");

                        JSONArray newData = new JSONArray();
                        newData.put(headers);

                        for (int i = 0; i < data.length(); i++) {
                            newData.put(data.getJSONObject(i));
                        }

                        JSONObject jsonBody = new JSONObject();
                        jsonBody.put("sheetname", "Test");
                        jsonBody.put("identifiers", identifiers);
                        jsonBody.put("data", newData);

                        byte[] bytes = service.generateExcel(jsonBody, data.length(), progressBar);

                        File tempFile = new File(selectedFolderPath + "/output.xlsx");

                        try (FileOutputStream fos = new FileOutputStream(tempFile)) {
                            fos.write(bytes);
                            fos.flush();
                        }

                        // Actualizar UI cuando se complete la tarea
                        SwingUtilities.invokeLater(() -> {
                            mensaje.setForeground(Color.GREEN);
                            mensaje.setText("Excel Generado Correctamente");
                        });

                    } catch (IOException | JSONException ex) {
                        // Manejar errores y actualizar la UI
                        SwingUtilities.invokeLater(() -> {
                            mensaje.setForeground(Color.RED);
                            mensaje.setText("Error: " + ex.getMessage());
                        });
                        Logger.getLogger(panel.class.getName()).log(Level.SEVERE, null, ex);
                    } finally {
                        // Habilitar el botón en la UI al finalizar
                        SwingUtilities.invokeLater(() -> btnExportar.setEnabled(true));
                        System.gc();
                    }
                }
            }).start(); // Iniciar el hilo
        }
    }//GEN-LAST:event_btnExportarActionPerformed

    private void actualizarRazonSocial() {
        razonSocial.removeAllItems();

        if (empresa.getSelectedIndex() == 2) {
            for (String empresa : empresasSede) {
                razonSocial.addItem(empresa);
            }
        } else if (empresa.getSelectedIndex() == 1) {
            for (String empresa : empresasFranquicia) {
                razonSocial.addItem(empresa);
            }
        }
    }

    public String formatConceptoPago(JCheckBox... checkBoxes) {
        final int[] values = {13, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12};
        final StringBuilder conceptoPago = new StringBuilder("{");
        boolean first = true;

        for (int i = 0; i < checkBoxes.length; i++) {
            if (checkBoxes[i].isSelected()) {
                if (!first) {
                    conceptoPago.append(",");
                }
                conceptoPago.append(values[i]);
                first = false;
            }
        }

        conceptoPago.append("}");
        return conceptoPago.toString();
    }

    private void chkDiciembreActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkDiciembreActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_chkDiciembreActionPerformed

    private void chkMatriculaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkMatriculaActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_chkMatriculaActionPerformed

    private void chkFebreroActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkFebreroActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_chkFebreroActionPerformed

    private void chkMarzoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkMarzoActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_chkMarzoActionPerformed

    private void chkAbrilActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkAbrilActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_chkAbrilActionPerformed

    private void chkMayoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkMayoActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_chkMayoActionPerformed

    private void chkJunioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkJunioActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_chkJunioActionPerformed

    private void chkJulioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkJulioActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_chkJulioActionPerformed

    private void chkAgostoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkAgostoActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_chkAgostoActionPerformed

    private void chkSetiembreActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkSetiembreActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_chkSetiembreActionPerformed

    private void chkOctubreActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkOctubreActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_chkOctubreActionPerformed

    private void chkNoviembreActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkNoviembreActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_chkNoviembreActionPerformed

    private void chkEneroActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkEneroActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_chkEneroActionPerformed

    private void txtFechaKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtFechaKeyPressed
        char c = evt.getKeyChar();

        // Allow only numbers and backspace
        if (!Character.isDigit(c) && c != KeyEvent.VK_BACK_SPACE) {
            evt.consume();
            return;
        }

        String text = txtFecha.getText();

        // Prevent entering more than 10 characters
        if (text.length() >= 10 && c != KeyEvent.VK_BACK_SPACE) {
            evt.consume();
            return;
        }

        // Auto-insert '/' at positions 2 and 5
        if ((text.length() == 2 || text.length() == 5) && c != KeyEvent.VK_BACK_SPACE) {
            txtFecha.setText(text + "/");
        }
    }//GEN-LAST:event_txtFechaKeyPressed

    private void empresaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_empresaActionPerformed
        actualizarRazonSocial();
    }//GEN-LAST:event_empresaActionPerformed

    public static void setMaxCharacters(JTextField textField, int maxChars) {
        AbstractDocument doc = (AbstractDocument) textField.getDocument();
        doc.setDocumentFilter(new DocumentFilter() {
            public void replace(FilterBypass fb, int offset, int length, String text, AttributeSet attrs) throws BadLocationException {
                if ((fb.getDocument().getLength() + text.length() - length) <= maxChars) {
                    super.replace(fb, offset, length, text, attrs);
                }
            }

            public void insertString(FilterBypass fb, int offset, String text, AttributeSet attr) throws BadLocationException {
                if ((fb.getDocument().getLength() + text.length()) <= maxChars) {
                    super.insertString(fb, offset, text, attr);
                }
            }
        });
    }

    private boolean isValidDate(String date) {
        // Check if the length is exactly 10 (dd/mm/yyyy)
        if (date.length() != 10) {
            return false;
        }

        // Check if the format is dd/mm/yyyy
        String[] parts = date.split("/");
        if (parts.length != 3) {
            return false;
        }

        String dayStr = parts[0];
        String monthStr = parts[1];
        String yearStr = parts[2];

        // Check if day, month, and year are numeric
        if (!dayStr.matches("\\d{2}") || !monthStr.matches("\\d{2}") || !yearStr.matches("\\d{4}")) {
            return false;
        }

        int day = Integer.parseInt(dayStr);
        int month = Integer.parseInt(monthStr);
        int year = Integer.parseInt(yearStr);

        // Check if month is valid (1-12)
        if (month < 1 || month > 12) {
            return false;
        }

        // Check if the day is valid for the given month and year
        int maxDay = getMaxDaysInMonth(month, year);
        if (day < 1 || day > maxDay) {
            return false;
        }

        return true;
    }

// Helper method to get max days in a month considering leap years for February
    private int getMaxDaysInMonth(int month, int year) {
        switch (month) {
            case 1:
            case 3:
            case 5:
            case 7:
            case 8:
            case 10:
            case 12:
                return 31;
            case 4:
            case 6:
            case 9:
            case 11:
                return 30;
            case 2:
                return (isLeapYear(year)) ? 29 : 28;
            default:
                return 0; // Invalid month
        }
    }

// Helper method to check if a year is a leap year
    private boolean isLeapYear(int year) {
        return (year % 4 == 0 && (year % 100 != 0 || year % 400 == 0));
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            // Set darker color values
            UIManager.put("control", new Color(30, 30, 30));
            UIManager.put("info", new Color(40, 40, 40));
            UIManager.put("nimbusBase", new Color(10, 10, 20));
            UIManager.put("nimbusAlertYellow", new Color(200, 160, 0));
            UIManager.put("nimbusDisabledText", new Color(100, 100, 100));
            UIManager.put("nimbusFocus", new Color(80, 120, 180));
            UIManager.put("nimbusGreen", new Color(130, 150, 40));
            UIManager.put("nimbusInfoBlue", new Color(50, 100, 200));
            UIManager.put("nimbusLightBackground", new Color(20, 20, 30));
            UIManager.put("nimbusOrange", new Color(160, 70, 0));
            UIManager.put("nimbusRed", new Color(140, 30, 20));
            UIManager.put("nimbusSelectedText", new Color(240, 240, 240));
            UIManager.put("nimbusSelectionBackground", new Color(60, 50, 100));
            UIManager.put("text", new Color(210, 210, 210));

            // Apply the Nimbus look and feel
            for (UIManager.LookAndFeelInfo info : UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        //</editor-fold>

        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(() -> {
            new panel().setVisible(true);
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JToggleButton btnExportar;
    private javax.swing.JCheckBox chkAbril;
    private javax.swing.JCheckBox chkAgosto;
    private javax.swing.JCheckBox chkDiciembre;
    private javax.swing.JCheckBox chkEnero;
    private javax.swing.JCheckBox chkFebrero;
    private javax.swing.JCheckBox chkJulio;
    private javax.swing.JCheckBox chkJunio;
    private javax.swing.JCheckBox chkMarzo;
    private javax.swing.JCheckBox chkMatricula;
    private javax.swing.JCheckBox chkMayo;
    private javax.swing.JCheckBox chkNoviembre;
    private javax.swing.JCheckBox chkOctubre;
    private javax.swing.JCheckBox chkSetiembre;
    private javax.swing.JComboBox<String> empresa;
    private javax.swing.JButton findFolder;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel mensaje;
    private javax.swing.JComboBox<String> periodo;
    private javax.swing.JProgressBar progressBar;
    private javax.swing.JComboBox<String> razonSocial;
    private javax.swing.JTextField txtFecha;
    private javax.swing.JLabel txtRuta;
    // End of variables declaration//GEN-END:variables
}
